#include <iostream>
#include <string>
#include <vector>

using intMatrix = std::vector<std::vector<int>>;

const size_t column = 1;

int inputStd()
{
	std::string		inputString{};
	bool			inputIsCorrect{ false };
	int				inputNumber{};

	while (false == inputIsCorrect)
	{
		try
		{
			std::getline(std::cin, inputString);
			inputNumber = std::stoi(inputString);

			inputIsCorrect = true;
		}
		catch (...)
		{
			std::cout << "Wrong input!" << std::endl;
		}
	}

	return inputNumber;
}

int findMax(const intMatrix& matrix, const size_t& size)
{
	int	maxElement = matrix[0][0];

	for (size_t i = 0; i < size; ++i)
	{
		if (matrix[i][column] > maxElement)
		{
			maxElement = matrix[i][column];
		}
	}
	return maxElement;
}

void fillMatrix(intMatrix& matrix, const size_t& size)
{
	for (size_t i = 0; i < size; ++i)
	{
		for (size_t j = 0; j < size; ++j)
		{
			matrix[i][j] = inputStd();
		}
	}
}

void findColumnAndStr(const intMatrix& matrix, const size_t& size, 
	const int& maxNumber)
{
	for (size_t i = 0; i < size; ++i)
	{
		for (size_t j = 0; j < size; ++j)
		{
			if (maxNumber > matrix[i][j])
			{
				std::cout << "[Row][Column] [Value] -> [" 
					<< i + 1 << "][" << j + 1 << "] [" <<
					matrix[i][j] << "]" << std::endl;
			}
		}
	}
}

void expandMatrix(intMatrix& matrix, const size_t& size)
{
	matrix.reserve(size);
	matrix.resize(size);

	for (auto& row : matrix)
	{
		row.reserve(size);
		row.resize(size, 0);
	}
}

void outputMatrix(intMatrix& matrix, const size_t& size)
{
	for (size_t i = 0; i < size; ++i)
	{
		for (size_t j = 0; j < size; ++j)
		{
			std::cout << "[" << matrix[i][j] << "]";
		}

		std::cout << std::endl;
	}
}

int main()
{
	intMatrix	matrix;
	size_t		matrixSize{};
	int			maxNumberInMatrix{};

	while (1 >= matrixSize)
	{
		std::cout << "Input matrix size: ";
		matrixSize = inputStd();
		if (1 >= matrixSize)
		{
			std::cout << "Wrong size! There is no second column in 0x0 or 1x1 matrix!"
				<< std::endl;
		}
	}

	expandMatrix(matrix, matrixSize);

	std::cout << "\nInput " << matrixSize * matrixSize << " numbers via Enter: " << std::endl;
	fillMatrix(matrix, matrixSize);

	std::cout << "\nYour matrix: " << std::endl;
	outputMatrix(matrix, matrixSize);

	maxNumberInMatrix = findMax(matrix, matrixSize);
	std::cout << "\nMax number in 2 column: " << maxNumberInMatrix << std::endl;

	std::cout << std::endl;
	findColumnAndStr(matrix, matrixSize, maxNumberInMatrix);

	return 0;
}